<?php

namespace SupNext\Controllers;

use Teknisa\Libs\Util\Environment;
use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class IdSisDosController {
  private $environment;
  private $util;

  public function __construct(Environment $environment, Util $util) {
    $this->environment = $environment;
    $this->util        = $util;
  }

  public function getIdSisDos(Request $request, Response $response) {
    try {
      $conditions = [
        "NRORG" => $this->environment->getNrorg()
      ];

      $id = $this->util->filteredDataSet($conditions, "getIdSisDos")[0]["IDSISDOS"];

      return $response->addDataSet(new DataSet("idSisDos", ["id" => $id, "status_code" => 200]));
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao pegar id: " . $exception->getMessage(), 500);
    }
  }
}
