<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Services\QuoteSheetGrid\CalculateTradingService as Service;
use SupNext\Services\QuoteSheetGrid\SaveAdditionalDataService as SaveAdditionalData;
use SupNext\Controllers\QuoteSheetGrid\AddRegionController as AddRegion;
use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class CalculateTradingController {
    private $service;
    private $saveAdditionalData;
    private $addRegion;
    private $util;

    public function __construct(Service $service, SaveAdditionalData $saveAdditionalData, AddRegion $addRegion, Util $util) {
        $this->service            = $service;
        $this->saveAdditionalData = $saveAdditionalData;
        $this->addRegion          = $addRegion;
        $this->addRegion          = $addRegion;
        $this->util               = $util;
    }

    public function calculateTrading(Request $request, Response $response) {
        $data = $request->getParameters()["params"];

        $query = $this->saveAdditionalData->generateUpdateQuery($data);

        $this->saveAdditionalData->updateItemColeCustom($query, $data);
        var_dump('');return;
        $this->addRegion->executeProcedureItemcol($data);

        $data["NRSEQAPUR"] = " ";
        $this->service->procAtualizaItmapur($data);

        $conditions = [
            "CDREGIAO"    => $data["CDREGIAO"],
            "CDFILIAL"    => $data["CDFILIAL"],
            "NRCOLEPRECO" => $data["NRCOLEPRECO"],
            "CDPRODUTO"   => $data["CDPRODUTO"],
            "CDMARCA"     => $data["CDMARCA"],
            "CDFORNECED"  => $data["CDFORNECED"],
            "NRORG"       => $data["NRORG"]
        ];

        $values = $this->util->filteredDataSet($conditions, "getUnitPriceAndVRPRE")[0];

        $conditions = [
            "CDREGIAO"    => $data["CDREGIAO"],
            "CDFILIAL"    => $data["CDFILIAL"],
            "NRCOLEPRECO" => $data["NRCOLEPRECO"],
            "CDPRODUTO"   => $data["CDPRODUTO"],
            "CDMARCA"     => $data["CDMARCA"],
            "CDFORNECED"  => $data["CDFORNECED"],
            "NRORG"       => $data["NRORG"]
        ];

        $trading = $this->util->filteredDataSet($conditions, "getItemColeTrading")[0];

        $percents = [
            "VRPERPRECUNIITMAT" => $data["current_unit_price"] === 0 ? 0 : (($trading["new_unit_price"] - $data["current_unit_price"]) / $data["current_unit_price"]) * 100,
            "VRPERPRECECOITMAT" => $trading["VRPRECECOITM"] == 0 ? 0 : (($values["VRPRECECOITM"] - $trading["VRPRECECOITM"]) / $trading["VRPRECECOITM"]) * 100,
            "VRPERPRECUNIITMUC" => 0,
            "VRPERPRECECOITMUC" => 0
        ];

        return $response->addDataSet(new DataSet("calculateTrading", $percents));
    }
}
