<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class GetFieldsAdditionalDataController {
  private $util;

  public function __construct(Util $util) {
    $this->util = $util;
  }

  public function getFieldsAdditionalData(Request $request, Response $response) {
    $data = $request->getParameters();

    try {
      $conditions = [
        "CDREGIAO"    => $data["CDREGIAO"],
        "CDFILIAL"    => $data["CDFILIAL"],
        "NRCOLEPRECO" => $data["NRCOLEPRECO"],
        "CDPRODUTO"   => $data["CDPRODUTO"],
        "CDMARCA"     => $data["CDMARCA"],
        "CDFORNECED"  => $data["CDFORNECED"],
        "NRORG"       => $data["NRORG"]
      ];

      $fields = array_merge(
        $this->util->filteredDataSet($conditions, "getFieldsAdditionalData"),
        $this->getReplicateDiscount($data)
      );

      return $response->addDataSet(new DataSet("getFieldsValue", $fields));
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao pegar valores dos campos da tab dados adicionais: " . $exception->getMessage(), 500);
    }
  }

  private function getReplicateDiscount(array $data): array {
    try{
      $conditions = [
        "CDFILIAL" => $data["CDFILIAL"],
        "NRORG"    => $data["NRORG"]
      ];

      $fields = $this->util->filteredDataSet($conditions, "getReplicateDiscount");

      return $fields;
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao pegar valores dos campos replicar disconto: " . $exception->getMessage(), 500);
    }
  }
}
