<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Services\QuoteSheetGrid\LoadBestPricesService as Service;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class LoadBestPricesController {
  private $service;

  public function __construct(Service $service) {
    $this->service = $service;
  }

  public function loadBestPrices(Request $request, Response $response) {
    $data = $request->getParameters();

    try {
      foreach ($data as $quote) {
        $this->service->excuteprocMelhorPrecoAuto($quote);
      }

      return $response->addDataSet(new DataSet("loadBestPrices", ["message" => "Carregamento dos melhores preços realizado com sucesso.", "status_code" => 200]));
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao carregar melhores preços: " . $exception->getMessage(), 500);
    }
  }
}