<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use Teknisa\Libs\Util\Environment;
use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class ValidateBuyerController {
  private $environment;
  private $util;

  public function __construct(Environment $environment, Util $util) {
    $this->environment = $environment;
    $this->util        = $util;
  }

  public function validateBuyer(Request $request, Response $response) {
    try {
      $data = $request->getParameters();
      $conditions = [
        "CDOPERADOR"  => $data["CDOPERADOR"],
        "NRORG"       => $this->environment->getNrorg()
      ];

      $password = $this->util->filteredDataSet($conditions, "getBuyerPassword")[0];

      if (md5($data["PASSWORD"]) != $password["CDSENHAOPERWEB"]) {
        return $response->setError(new Error("sup::INVALID_PASSWORD", 400));
      }

      return $response->addDataSet(new DataSet("validateBuyer", ["message" => "OK", "status_code" => 200]));
    } catch (\Exception $exception) {
      throw new \Exception("Erro a validar comprador: " . $exception->getMessage(), 500);
    }
  }
}
