<?php

namespace SupNext\Services\QuoteSheetGrid;

use Doctrine\DBAL\Connection;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class CalculateTradingService {
    private $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function procAtualizaItmapur(array $data): void {
        try {
            $procedure = new StoredProcedure($this->connection, "ATUALIZA_ITMAPUR");

            $procedure->addParam(new Param("P_CDCENTCMP",   Param::PARAM_INPUT,  $data["CDFILCENT"],   Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_NRSEQAPUR",   Param::PARAM_INPUT,  $data["NRSEQAPUR"],   Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDPRODUTO",   Param::PARAM_INPUT,  $data["CDPRODUTO"],   Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDMARCA",     Param::PARAM_INPUT,  $data["CDMARCA"],     Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDFORNECED",  Param::PARAM_INPUT,  $data["CDFORNECED"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDREGIAO",    Param::PARAM_INPUT,  $data["CDREGIAO"],    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_NRCOLEPRECO", Param::PARAM_INPUT,  $data["NRCOLEPRECO"], Param::PARAM_TYPE_STR));

            $procedure->execute();
        } catch (\Exception $exception) {
            throw new \Exception("Erro ao executar procedure atualiza itmmapur: " . $exception->getMessage(), 500);
        }
    }
}
