<?php

namespace SupNext\Services\QuoteSheetGrid;

use SupNext\Util\Util;

class ExcludeItemsWithZeroPriceService {
    private $util;

    public function __construct(Util $util) {
        $this->util = $util;
    }

    public function deleteItemPriceZero(array $data): void {
        try {
            $query = "DELETE FROM ITEMCOLE
                      WHERE CDFILIAL = :P_CDFILIAL
                            AND NRCOLEPRECO = :P_NRCOLEPRECO
                            AND NRORG = :P_NRORG
                            AND CDREGIAO = NVL(:P_CDREGIAO, CDREGIAO)
                            AND VRPRECUNIITM = 0";

            $params = [
                "P_CDFILIAL"    => $data["CDFILIAL"],
                "P_NRCOLEPRECO" => $data["NRCOLEPRECO"],
                "P_NRORG"       => $data["NRORG"],
                "P_CDREGIAO"    => $data["CDREGIAO"]
            ];

            $this->util->crud($query, $params);
        } catch (Exception $exception) {
            throw new \Exception("Erro ao executar query deleção itens com preço zerado: " . $exception->getMessage(), 500);
        }
    }
}