<?php

namespace SupNext\Services\QuoteSheetGrid;

use Doctrine\DBAL\Connection;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class GetHistoryTradingService {
    private $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function procPrecoEconAf($data) {
        try {
            $procedure = new StoredProcedure($this->connection, 'PRECO_ECON_AF');

            $procedure->addParam(new Param("P_CDFILIAL",    Param::PARAM_INPUT,  $data["CDFILIAL"],    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDFILDEST",   Param::PARAM_INPUT,  $data["CDFILDEST"],   Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDFILLANC",   Param::PARAM_INPUT,  $data["CDFILLANC"],   Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_NRAUTOFORN",  Param::PARAM_INPUT,  $data["NRAUTOFORN"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDPRODUTO",   Param::PARAM_INPUT,  $data["CDPRODUTO"],   Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDMARCA",     Param::PARAM_INPUT,  $data["CDMARCA"],     Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_DTPROGENTAF", Param::PARAM_INPUT,  $data["DTPROGENTAF"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_VRPRECECO",   Param::PARAM_OUTPUT, NULL,                   Param::PARAM_TYPE_STR, 10));

            return $procedure->execute();
        } catch (\Exception $exception) {
            throw new \Exception("Erro ao executar procedure preco econ af: " . $exception->getMessage(), 500);
        }
    }
}