import { TekGrid } from '@zeedhi/teknisa-components-common';
import { ModalService } from '@zeedhi/common';
import { Metadata } from '@zeedhi/core';
import { Utilities } from '@/util/Utilities';

export class ConsultPriceListController {
  private utilities: Utilities;

  constructor() {
    this.utilities = new Utilities();
  }

  public async createModal(): Promise<void> {
    await ModalService.createFromJson(
      '/modals/quoteSheetGrid/consultPriceListModal',
      true,
    );
  }

  public destroyModal(): void {
    ModalService.getModal('consultPriceListModal')?.destroy();
  }

  public openModal(): void {
    const grid = Metadata.getInstance<TekGrid>('multipleLevelsQuotationGrid');

    if (!grid.selectedRows.length || grid.selectedRows.length > 1) {
      this.utilities.showWarningDialog('Selecione uma cotação para consultar lista de preço.');

      return;
    }

    ModalService.getModal('consultPriceListModal').show();
  }

  public closeModal(): void {
    ModalService.getModal('consultPriceListModal').hide();
  }

  public get setFilter() {
    const grid = Metadata.getInstance<TekGrid>('multipleLevelsQuotationGrid');
    const row = grid.selectedRows[0];

    return {
      CDFILIAL: row.CDFILIAL,
      NRCOLEPRECO: row.NRCOLEPRECO,
    };
  }
}
